
From: NeilBrown <neilb@cse.unsw.edu.au>

As 'nfs_acceptable' uses the authnetication user in it's checks, the
filehandle might not be truely "stale" - EACCES is safer.

Thanks Olaf Kirch <okir@suse.de> and others.

Signed-off-by: Neil Brown <neilb@cse.unsw.edu.au>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/fs/exportfs/expfs.c |    7 ++++++-
 1 files changed, 6 insertions(+), 1 deletion(-)

diff -puN fs/exportfs/expfs.c~knfsd-return-eacces-instead-of-estale-for-certain-filehandle-lookup-failures fs/exportfs/expfs.c
--- 25/fs/exportfs/expfs.c~knfsd-return-eacces-instead-of-estale-for-certain-filehandle-lookup-failures	2004-09-02 20:28:40.204580192 -0700
+++ 25-akpm/fs/exportfs/expfs.c	2004-09-02 20:28:40.208579584 -0700
@@ -283,7 +283,12 @@ find_exported_dentry(struct super_block 
 
 	/* drat - I just cannot find anything acceptable */
 	dput(result);
-	return ERR_PTR(-ESTALE);
+	/* It might be justifiable to return ESTALE here,
+	 * but the filehandle at-least looks reasonable good
+	 * and it just be a permission problem, so returning
+	 * -EACCESS is safer
+	 */
+	return ERR_PTR(-EACCES);
 
  err_target:
 	dput(target_dir);
_
